# -*- coding: utf-8 -*-
"""
Created on Thu Feb 13 12:08:27 2025

@author: mstep
"""

# Nicomachus's theorem
# See https://en.wikipedia.org/wiki/Squared_triangular_number

def check_nicomachus_observation(max):
    '''Check Nicomachus's original observation for i = 1, 2, ..., n.'''
    odd_number = 1

    for n in range(1, max + 1):
        # Add up the next i odd nmbers.
        sum_of_odds = 0
        for next_odd in range(n):
            sum_of_odds += odd_number
            odd_number += 2

        # Calculate i ** 3.
        n_cubed = n ** 3

        # Print the result.
        print(f'{n:3}: {sum_of_odds} == {n_cubed}')

def check_nicomachus_theorem(max):
    '''Check Nicomachus's theorem for i = 1, 2, ..., n.'''
    for n in range(1, max + 1):
        # Add up cubes 1**3 + 2**3 + 3**3 + ... + n**3.
        sum_of_cubes = 0
        for i in range(1, n + 1):
            sum_of_cubes += i ** 3

        # Calculate the sum of the numbers and square the result.
        sum_of_numbers = 0
        for i in range(1, n + 1):
            sum_of_numbers += i
        sum_squared = sum_of_numbers * sum_of_numbers

        # Print the result.
        print(f'{n:3}: {sum_of_cubes} == {sum_squared}')

num_values = 20

print('Nicomachus\'s Observation')
check_nicomachus_observation(num_values)

print('\nNicomachus\'s Theorem')
check_nicomachus_theorem(num_values)


def check_nicomachus_theorem_comprehension(max):
    '''Check Nicomachus's theorem for i = 1, 2, ..., n.'''
    for n in range(1, max + 1):
        # Add up cubes 1**3 + 3**3 + ... + n**3.
        sum_of_cubes = sum([i**3 for i in range(1, n+1)])

        # Calculate the sum of the numbers and square the result.
        sum_squared = sum([i for i in range(1, n + 1)]) ** 2

        # Print the result.
        print(f'{n:3}: {sum_of_cubes} == {sum_squared}')


print('\nNicomachus\'s Observation w/Comprehensions')
check_nicomachus_theorem_comprehension(num_values)


def check_sum_of_odds(max):
    '''Check 1 + 3 + 5 + ... + (2*N)-1 = N**2'''
    for n in range(1, max + 1):
        # Add up odds.
        sum_of_odds = 0
        for i in range(1, 2 * n - 1 + 2, 2):
            sum_of_odds += i

        # Calculate n**2.
        n_squared = n ** 2

        # Print the result.
        print(f'{n:3}: {sum_of_odds} == {n_squared}')

def check_sum_of_odds_comprehension(max):
    '''Check 1 + 3 + 5 + ... + (2*N)-1 = N**2'''
    for n in range(1, max + 1):
        # Add up odds.
        sum_of_odds = sum([(2 * i - 1) for i in range(1, n+1)])

        # Calculate n**2.
        n_squared = n ** 2

        # Print the result.
        print(f'{n:3}: {sum_of_odds} == {n_squared}')

print('\nSum of odds')
check_sum_of_odds(num_values)

print('\nSum of odds w/Comprehensions')
check_sum_of_odds_comprehension(num_values)
